package main;

import java.util.HashMap;
import java.util.Map;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageListener;
import javax.jms.Queue;
import javax.jms.Session;
import javax.jms.TextMessage;

import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.jms.HornetQJMSClient;
import org.hornetq.integration.transports.netty.NettyConnectorFactory;
import org.hornetq.jms.server.JMSServerManager;

public class JMSHelper implements MessageListener {

	private static JMSHelper instance = new JMSHelper();

	private JMSServerManager jmsServerManager;

	private JMSHelper() {
	}

	public static JMSHelper getInstance()
	{
		return instance;
	}

	public JMSServerManager getJMSServerManager()
	{
		return jmsServerManager;
	}

	public void init()
	{
		// try
		// {
		// FileConfiguration configuration = new FileConfiguration();
		// configuration.setConfigurationUrl("hornetq-configuration.xml");
		// configuration.start();
		//
		// HornetQServer server = HornetQServers
		// .newHornetQServer(configuration);
		// jmsServerManager = new JMSServerManagerImpl(server,
		// "hornetq-jms.xml");
		// // if you want to use JNDI, simple inject a context here or don't
		// // call this method and make sure the JNDI parameters are set.
		// jmsServerManager.setContext(null);
		// jmsServerManager.start();
		// System.out.println("STARTED::");
		// initListener();
		//
		// }
		// catch (Throwable e)
		// {
		// System.out.println("FAILED::");
		// e.printStackTrace();
		// }
	}

	public void initListener()
	{
		Connection connection = null;
		try
		{
			// Step 1. Directly instantiate the JMS Queue object.
			Queue queue = HornetQJMSClient.createQueue("exampleQueue");

			Map<String, Object> connectionParams = new HashMap<String, Object>();
			connectionParams
					.put(
							org.hornetq.integration.transports.netty.TransportConstants.PORT_PROP_NAME,
							5445);

			TransportConfiguration transportConfiguration = new TransportConfiguration(
					NettyConnectorFactory.class.getName(), connectionParams);
			
			Map<String, Object> connectionParamsBackup = new HashMap<String, Object>();
			connectionParams
					.put(
							org.hornetq.integration.transports.netty.TransportConstants.PORT_PROP_NAME,
							5446);

			TransportConfiguration transportConfigurationBackup = new TransportConfiguration(
					NettyConnectorFactory.class.getName(), connectionParamsBackup);
			

			// Step 3 Directly instantiate the JMS ConnectionFactory object
			// using that TransportConfiguration
			ConnectionFactory cf = HornetQJMSClient
					.createConnectionFactory(transportConfiguration, transportConfigurationBackup);

			// Step 4.Create a JMS Connection
			connection = cf.createConnection();

			// Step 5. Create a JMS Session
			Session session = connection.createSession(false,
					Session.AUTO_ACKNOWLEDGE);

			// Step 9. Create a JMS Message Consumer
			MessageConsumer messageConsumer = session.createConsumer(queue);

			// Step 10. Start the Connection
			connection.start();

			messageConsumer.setMessageListener(this);

		}
		catch (Exception e)
		{
			e.printStackTrace();

		}
		finally
		{
			try
			{
				// // Step 9. Be sure to close our resources!
				// if (session != null)
				// {
				// session.close();
				// }
				// if (connection != null)
				// connection.close();

				// Step 10. Stop the server
				// server.stop();
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
	}

	@Override
	public void onMessage(Message arg0)
	{
		System.out.println("In here");
		try
		{
			TextMessage tM = ((TextMessage) arg0);
			System.out.println("Message Received: " + tM.getText());
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}
